#include <iostream.h>
#include <netdb.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#include "XxTimer.h"
#include "XxAutoInit.h"

NULLINIT (XxTimer::XxTimerSet::SetOwner *pTimerOwner);

class InitClass {
private:
    int Dummy;
public:
    InitClass (void) {
        XxTimer::Init ();
    };
};

AUTOINIT InitClass InitObject;

void XxTimer::Init (void)
{
    if (pTimerOwner == NULL) {
        pTimerOwner = new XxTimerSet::SetOwner;
        XxTimer::RefreshMsCurTime ();

        AUTOINIT_TRACE ("XxTimer::Init");
    };
};

long XxTimer::MsCurTime   = 0;
long XxTimer::MsStartTime = 0;
int  XxTimer::TimerCount  = 0;

int XxTimer::RestartTimer (void)
{
    int RetVal;

    if (MsRestart == 0) {
        MsTimeOut  = 0;
        RetVal     = 1;
    } else {
        RetVal     = 1 + (MsCurTime - MsTimeOut) / MsRestart;
        MsTimeOut += (MsRestart * RetVal);
    };
    return RetVal;
};

void XxTimer::HandleTimeOut (int)
{
}; 

XxTimer::XxTimer (long MsRestart) : Member (this)
{
    Member.Attach (*pTimerOwner);
    XxTimer::MsTimeOut = MsCurTime;
    XxTimer::MsRestart = MsRestart;
    XxTimer::TimerCount++;
    RestartTimer ();
};

XxTimer::~XxTimer (void)
{
    XxTimer::TimerCount--;
};

void XxTimer::RefreshMsCurTime (void)
{
    struct timeval CurTime;
    struct timezone TimeZone;
    long   MsNewTime;

    gettimeofday (&CurTime, &TimeZone);

    MsNewTime =   (CurTime.tv_usec / 1000) + (CurTime.tv_sec * 1000);

    if (MsCurTime == 0) {
        MsStartTime = MsNewTime - 1;
        MsCurTime   = 1;
    } else {
        MsCurTime   = MsNewTime - MsStartTime;
    };
}

void XxTimer::HandleTimers (int &mSec)
{
    XxTimer *pTimer;
    long     MsMinTime, MsTmpTime;
    int      Count;

    MsMinTime = 0;

    pTimer = pTimerOwner->GetFirst ();

    while (pTimer != NULL) {
        MsTmpTime = pTimer->MsTimeOut;
        if (MsTmpTime != 0) {
            if (MsTmpTime <= MsCurTime) {
                Count = pTimer->RestartTimer ();
                pTimer->HandleTimeOut (Count);
                MsTmpTime = pTimer->MsTimeOut;
            };
            if (MsTmpTime >= MsCurTime) {
                if (MsMinTime == 0 || MsTmpTime < MsMinTime) {
                    MsMinTime = MsTmpTime;
                };
            };
        };
        pTimer = pTimer->Member.GetNext ();
    };
    if (MsMinTime != 0) {
        mSec = MsMinTime - MsCurTime;
    } else {
        mSec = -1;
    };
};

void XxTimer::SetTimeOut (int mSec)
{
    MsTimeOut = MsCurTime + mSec;
};

void XxTimer::SetRestart (int mSec)
{
    XxTimer::MsRestart = mSec;
    RestartTimer ();
};

void XxTimer::Stop (void)
{
    SetRestart (0);
};
